/* SPDX-License-Identifier: MIT
 * Small Data Compression Library
 * Copyright (c) 2020 Kingizor */

#include <stdio.h>
#include "sd_comp.h"

static long get_file_size (const char *fn) {
    FILE *f = fopen(fn, "rb");
    long len;
    if ((f == NULL)
    || (fseek(f, 0, SEEK_END) == -1)
    || ((len = ftell(f))      == -1))
        return -1;
    fclose(f);
    return len;
}

int main (int argc, char *argv[]) {

    if (argc != 3) {
        #define APP_NAME "sd_comp"
        puts("Usage: ./" APP_NAME " input output");
        return 1;
    }

    if (sd_compress_file_to_file(argv[2], argv[1])) {
        fprintf(stderr, "%s\n", sd_get_error());
        return 2;
    }

    {
        long input_len  = get_file_size(argv[1]);
        long output_len = get_file_size(argv[2]);
        printf("Compressed %ld to %ld bytes. (%lX -> %lX)\n",
            input_len, output_len, input_len, output_len
        );
    }
    return 0;
}

