/* SPDX-License-Identifier: MIT
 * Small Data Compression Library
 * Copyright (c) 2020 Kingizor */

#include <stdio.h>
#include <stdlib.h>
#include "sd_comp.h"
#include "sd_internal.h"

int main (int argc, char *argv[]) {

    size_t offset = 0;

    if (argc < 3 || argc > 4) {
        #define APP_NAME "sd_decomp"
        puts("Usage: ./" APP_NAME " output input [offset]");
        return 1;
    }

    if (argc == 4)
        offset = strtol(argv[3], NULL, 0);

    if (sd_decompress_file_to_file(argv[1], argv[2], offset)) {
        fprintf(stderr, "%s\n", sd_get_error());
        return 2;
    }

    puts("Done.");
    return 0;
}

